package picassotransformwrapper;

import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
//import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;

import android.content.Context;
import android.graphics.Color;
import android.graphics.PointF;
import android.widget.ImageView;
import android.widget.TextView;
import com.squareup.picasso.Picasso;
import java.util.List;

import jp.wasabeef.picasso.transformations.gpu.ColorBalanceFilterTransformation;


//@ActivityObject
@Author("Github: Daichi Furiya, Wrapped by: Johan Schoeman")
//@Version(1.00f)
@ShortName("ColorBalanceFilterTransformation")
@DependsOn(values={"picasso-2.5.2"})
public class ColorBalanceFilterWrapper {


	private BA ba;
	private ColorBalanceFilterTransformation sft;
	
 	public void Initialize(BA ba) {
         this.ba = ba;
	}


	private Bitmap bm = null;
    public void setImageBitmap(Bitmap bm) {
	  this.bm = bm;
	} 
	
	
	private float[] shawdows = {0.0f, 0.0f, 0.0f};
    public void setShawdows(float[] shawdows) {
        this.shawdows = shawdows;
    }

	private float[] midtones = {0.0f, 0.0f, 0.0f};
    public void setMidtones(float[] midtones) {
        this.midtones = midtones;
    }

	private float[] highlights = {0.0f, 0.0f, 0.0f};
    public void setHighlights(float[] highlights) {
        this.highlights = highlights;
    }

	private boolean preserveLuminosity = true;
    public void setPreserveLuminosity(boolean preserveLuminosity) {
        this.preserveLuminosity = preserveLuminosity;
    }
	
	
	public Object applyColorBalanceFilterTransformation() {
        sft = new ColorBalanceFilterTransformation(ba.context, shawdows, midtones, highlights, preserveLuminosity);
	    return sft.transform(bm);		
	}
	
   
}
